#!/usr/bin/python
#coding: utf-8;
############################################################################
#                                                                          #
#    This file 'setup.py'                                                  #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2006      by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from distutils.core import setup
from distutils.extension import Extension

classifiers=["Development Status :: 4 - Beta",
     "License :: OSI Approved :: GNU General Public License (GPL)",
     "Programming Language :: Python",
     "Topic :: Software Development :: Libraries :: Python Modules",
     "Topic :: Software Development :: Object Brokering"]
setup(
    name="SPyRO",
    version="0.9.22",
    author="Eric Sadit Tellez Avila".decode("latin1").encode('utf8'),
    author_email="sadit@lsc.fie.umich.mx",
    url="http://lsc.fie.umich.mx/~sadit/spyro",
    license="GPL",
    platforms=["POSIX",'any'],
    classifiers=classifiers,
    description="SPyRO: Simple Python Remote Objects",
    long_description="""
    SPyRO is a multilingual Object Request Broker (ORB). SPyRO uses the most
    efficient available connection between peers to minimize the costs of
    transport and parsing in the communication. SPyRO provides transparent
    and translucent remote object access.

    News:

    Bug fixes release. Pemissions and security policies were enhanced.
    
    """,
    packages=['threadutils','warn', 'shttp', "SPyRO"],
)
