#coding: iso-8859-1;
############################################################################
#                                                                          #
#    This file 'shttp/uri.py'                                         #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################
""" A couple of functions to interpret and manage URIs."""
import sre
import os
URI = sre.compile(r'(?P<protocol> [\d\w]+)://(?P<host> [^:/]+):?(?P<port> \d*)(?P<path> /[^\#\?]*)? (?P<query> \?[^\#]+)? (?P<sharp> \#.+)?',sre.I|sre.X)
QUERYSEP = sre.compile(r'(?P<path> [^#]+)\?(?P<querysep> [^\?]+)$',sre.I|sre.X)

def query_string(uri):
    s = QUERYSEP.search(uri)
    if s == None or not s.groupdict().has_key('querysep'):
        return ""
    else:
        return s.groupdict()['querysep']
    
first_slash = sre.compile(r"^/+")
def split_query(uri):
    s=QUERYSEP.search(uri)
    if s == None:
        return uri
    else:
        return s.groups()

def normlocation(dictmatch):
    path = dictmatch['path']
    if not (path is None) and path != '' and path != '/':
        path = os.path.normpath(first_slash.sub("/",path))
    else:
        path = '/'
    return "%s%s%s"%(path, dictmatch['query'] or '', dictmatch['sharp'] or '')

def normurldict(d, host):
    url = d['protocol'] + "://" + host
    port = d['port']
    if port: url = url + ":" + port
    url = url + normlocation(d)
    return url

def normurl(urlarg):
    m = URI.match(urlarg)
    if m is None: return urlarg
    d = m.groupdict()
    return normurldict(d, d['host'])
