#!/usr/bin/python -OO
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'pyidx.py'
#    is part of 'AFFAIRS'          #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import sys,os
import sre
import SPyRO as spyro
from SPyRO import policies
import warn

addr = ('127.0.0.1',59195)
proto = 'XMLRPC'
compress = False

AUTHFAIL = {'SET':0,'GET':0,'CALL_':0,'CALL':0,'ATTR_':0}
def run(authobj, authmustfail):
    for objname, results in (
        ('publicallowcall',          {'SET':0,'GET':0,'CALL_':0,'CALL':1,'ATTR_':0}),
        ('publicallowallcall',       {'SET':0,'GET':0,'CALL_':1,'CALL':1,'ATTR_':0}),
        ('publicallowall',           {'SET':1,'GET':1,'CALL_':1,'CALL':1,'ATTR_':1}),
        ('publicallowallbutdeny_',   {'SET':1,'GET':1,'CALL_':0,'CALL':1,'ATTR_':0}),
        
        ('authallowcall',          {'SET':0,'GET':0,'CALL_':0,'CALL':1,'ATTR_':0}),
        ('authallowallcall',       {'SET':0,'GET':0,'CALL_':1,'CALL':1,'ATTR_':0}),
        ('authallowall',           {'SET':1,'GET':1,'CALL_':1,'CALL':1,'ATTR_':1}),
        ('authallowallbutdeny_',   {'SET':1,'GET':1,'CALL_':0,'CALL':1,'ATTR_':0})

        ):
        if objname.startswith("public"):
            auth = None
        else:
            auth = authobj

        comm=spyro.Client(addr, "/SPyRO?%s"%proto, compress=compress)
        test = comm.getobj(objname, auth)
        res = {}
        try:
            test.a
            res['GET'] = 1
        except:
            res['GET'] = 0
            
        try:
            test.a = "A"
            res['SET'] = 1
        except:
            res['SET'] = 0
                
        try:
            test.echo("hola")
            res['CALL'] = 1
        except:
            res['CALL'] = 0
        
        try:
            test._priv()
            res['CALL_'] = 1
        except:
            res['CALL_'] = 0

        try:
            test._a
            res['ATTR_'] = 1
        except:
            res['ATTR_'] = 0

        print "\*****************>", objname
        if authmustfail and objname.startswith("auth"):
            if res == AUTHFAIL:
                print "ok, auth fallo sin poder acceder"
            else:
                print "Auth no fallo, debio negar todos los accesos"
                print "obtenido: ",res
                import sys
                sys.exit(0)
        elif res == results:
            print "ok"
        else:
            print "diferencias encontradas"
            print "obtenido: ",res
            print "esperado: ",results
            import sys
            sys.exit(0)
        comm.close()

authobj = policies.AuthPasswordRequest('sadit','passwordprueba')

print "==========================0 Con autenticacion"
run(authobj, False)
print "\n\n==========================1 Sin autenticacion"
run(None, True)
