#!/usr/bin/python -OO
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'SPyRO/test/auth/server.py'                                 #
#    is part of 'SPyRO'                                                    #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #  
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import sys,os
import sre
import SPyRO as spyro
from SPyRO import policies

import warn

class AuthTest:
    def __init__(self):
        self.a="ATTR OK"
        self._a = "_ATTR"
        self.__spyro_formats__ = {
		'echo' : (('x','ifs'), ),
	}

    def echo(self,x):
        return "ECHO:" + str(x)
    
    def _priv(self):
        return "PRIVATE"

def startserver():
    addr=('0.0.0.0',59195)
    TT0 = AuthTest()
    server = spyro.Server(addr, "/")
    #atexit.register(index.close)
    server.setobj('publicallowcall', TT0, policies.PublicAllowCall())
    server.setobj('publicallowallcall', TT0, policies.PublicAllowAllCall())
    server.setobj('publicallowall', TT0, policies.PublicAllowAll())
    server.setobj('publicallowallbutdeny_', TT0, policies.PublicAllowAllButDenyUnderscore())

    authdb = {'sadit': 'passwordprueba'}
    server.setobj('authallowcall', TT0, policies.AuthAllowCall(authdb))
    server.setobj('authallowallcall', TT0, policies.AuthAllowAllCall(authdb))
    server.setobj('authallowall', TT0, policies.AuthAllowAll(authdb))
    server.setobj('authallowallbutdeny_', TT0, policies.AuthAllowAllButDenyUnderscore(authdb))
    try:
        print "Sirviendo en ", addr
        server.serve_forever()
    except Exception, e:
        warn.warn(e)

if __name__ == '__main__':
    import threadutils
    #threadutils.forkdaemon()
    startserver()
