#!/usr/bin/python -OO
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'pyidx.py'
#    is part of 'AFFAIRS'          #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import sys,os
import sre
import SPyRO as spyro
import warn
import threadutils
from threadutils import ThreadPool, ServerInThread
import time

try:
    import psyco
    psyco.full()
except:
    print sys.stderr, "The psyco module is not present"

try:
    True
except:
    True = 1
    False = 0

def starttest(number,proto,compress=False):
    addr=('127.0.0.1',59195)

    comm=spyro.Client(addr, "/SPyRO?%s"%proto, compress=compress)
    test = comm.getobj('TT0')
    clock = time.clock()
    times = time.time()
    
    for k in range(0, number):
        a= test.a, test.b, test.c, test.d, test.e, test.f, test.g
        b= test.statistics()
	print a, b
	#print b
    clock = time.clock() - clock
    times = time.time() - times
    comm.close()
    return (times, clock)

#threadutils.forkdaemon()

realfile = open("filetimeA_real.dat",'w')
userfile = open("filetimeA_user.dat","w")
#protocolos = ("PICKLE0", "PICKLE1", "PICKLE2", "XMLRPC")
protocolos = ("PICKLE0", "PICKLE1", "PICKLE2", "XMLRPC")
realfile.write(" ".join(('operaciones',)+ protocolos) + "\n")
userfile.write(" ".join(('operaciones',)+ protocolos) + "\n")

for num in range(200,1050,200):
    realfile.write("%d "%num)
    userfile.write("%d "%num)
    for proto in protocolos:
        realtime = 0
        usertime = 0
        rep = 1.0
        for i in range(0,int(rep)):
            _realtime, _usertime = starttest(num, proto)
            realtime = realtime + _realtime
            usertime = usertime + _usertime
        realfile.write("%f "%(realtime/rep))
        userfile.write("%f "%(usertime/rep))
    realfile.write("\n")
    userfile.write("\n")
    realfile.flush()
    userfile.flush()
realfile.close()
userfile.close()

# for proto in ("MARSHAL", "PICKLE0", "PICKLE1", "PICKLE2", "XMLGENERIC",
#           "WDDX", "XMLRPC", "SOAP"):
#     f = file("exprA.dat",'w')
#     for num in range(200,4050,200):
#         realtime = 0
#         usertime = 0
#         #rep = 10.0
#         rep = 5.0
#         #print range(0,int(rep))
#         for i in range(0,int(rep)):
#             _realtime, _usertime = starttest(num, proto)
#             realtime = realtime + _realtime
#             usertime = usertime + _usertime
#         print  >>f, proto, num, realtime/rep, usertime/rep
#         f.flush()
#     f.close()

if __name__ == '__mainX__':
    import hotshot, hotshot.stats, test.pystone
    prof = hotshot.Profile("stones.prof")
    print prof.runcall(starttest)
    prof.close()
    stats = hotshot.stats.load("stones.prof")
    stats.strip_dirs()
    print stats.sort_stats.__doc__
    stats.sort_stats('cumulative', 'calls', 'time')
    stats.print_stats(30)

