#!/usr/bin/python -OO
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'pyidx.py'
#    is part of 'AFFAIRS'          #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import sys,os
import sre
import SPyRO as spyro
from SPyRO import policies
import warn

addr = ('127.0.0.1',59195)
proto = 'XMLRPC-Legacy'
#proto = 'MARSHAL'
compress = False

AUTHFAIL = {'CALL_':0,'CALL':0}
def run(authobj, authmustfail):
    for objname, results in (
        ('publicallowcall',          {'CALL_':0,'CALL':1}),
        ('publicallowallcall',       {'CALL_':1,'CALL':1}),
        ('publicallowall',           {'CALL_':1,'CALL':1}),
        ('publicallowallbutdeny_',   {'CALL_':0,'CALL':1}),
        
        ('authallowcall',          {'CALL_':0,'CALL':1,}),
        ('authallowallcall',       {'CALL_':1,'CALL':1,}),
        ('authallowall',           {'CALL_':1,'CALL':1,}),
        ('authallowallbutdeny_',   {'CALL_':0,'CALL':1,})

        ):
        if objname.startswith("public"):
            auth = None
        else:
            auth = authobj

        comm=spyro.Client(addr, "/SPyRO?%s"%proto, compress=compress)
        res = {}
        try:
            comm.callMethodGuess(objname,'echo', ['hola'], auth=authobj)
            res['CALL'] = 1
        except:
            res['CALL'] = 0

        try:
            comm.callMethodGuess(objname,'_priv',(), auth=authobj)
            res['CALL_'] = 1
        except:
            res['CALL_'] = 0

        if authmustfail and objname.startswith("auth"):
            if res == AUTHFAIL:
                print "ok, auth fallo sin poder acceder"
            else:
                print "Auth no fallo, debio negar todos los accesos"
                print "obtenido: ",res
                import sys
                sys.exit(0)
        elif res == results:
            print "ok"
        else:
            print "diferencias encontradas ", objname
            print "obtenido: ",res
            print "esperado: ",results
            import sys
            sys.exit(0)
	try:
            comm.close()
	except:
            pass

authobj = policies.AuthPasswordRequest('sadit','passwordprueba')
print "==========================0 Con autenticacion"
run(authobj, False)
print "\n\n==========================1 Sin autenticacion"
#run(None, True)
