#coding: iso-8859-1;
############################################################################
#                                                                          #
#    This file 'threadutils/__init__.py'                                   #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from PeriodicExecution import *
from ServerInThread import *
from ThreadPool import *
import warn
warn = warn.Warn('threadutils')

__doc__ = """ Thread utilities or useful classes based on thread usage """
__version__ = '0.1'

__all__ = [ "PeriodicExecution", "ServerInThread", "ThreadPool", "ThreadPoolShared", "forkdaemon"]

import os, sys

def forkdaemon(new_stdout=None,new_stderr=None,new_stdin=None,
               new_cwd=os.getcwd(),msg=None):
    """ A simple (not double fork) daemon generator. """
    try:
        child = os.fork()
        if child > 0:
            sys.exit(0)
    except OSError, e:
        warn.warn("Fork: %d (%s)" % (e.errno, e.strerror))
        sys.exit(1)
    os.chdir(new_cwd)
    os.setsid()
    os.umask(0)
    if new_stderr is None:
        errfile = open("/dev/null","wb+")
    else:
        errfile = new_stderr

    if new_stdout is None:
        outfile = open("/dev/null","wb+")
    else:
        outfile = new_stdout

    if new_stdin is None:
        infile = open("/dev/null","rb")
    else:
        infile = new_stdin
    os.dup2(errfile.fileno(), sys.stderr.fileno())
    os.dup2(outfile.fileno(), sys.stdout.fileno())
    os.dup2( infile.fileno(),  sys.stdin.fileno())
